/* this file collects some functions managing those parts of a progress
 * dialog appearing whenever files are being copied,that are the same on
 * each such occasion like a throuput display,a display for the time
 * remaining,one for the time already passed */

#ifndef DATACOPYDLG_H
#define DATACOPYDLG_H

#include <gtk/gtk.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <time.h>

/* this is the structure passed to and obtained from all the functions
 * of datacopydlg.c */
typedef struct 
{
	GtkWidget *messagebox;
	GtkWidget *progress;
	GtkWidget *infoline;
	int totalsize;
	int bytesdone;

	int starttime;
	int bytessincelastmeasure;
	int lastmeasure;
	float currentthroughput;
} datacopydlg_dlginfo;
	
void datacopydlg_destroy(datacopydlg_dlginfo *dlg);
/* update the informations in datacopydlg_dlginfo and display changes 
 * this function should be called whenever a new block of data has been
 * processed */
void datacopydlg_newdatablock(datacopydlg_dlginfo *dlg,int size);
/* create a progress box with title for processing totalsize bytes of data,
 * stophandler gets called whenever the user terminates the process by
 * clicking the stop button. if NULL,stop button will not even be visible
 * data can be a pointer to some additional data passed to the signal handler
 * but can also be set to NULL if not needed */
datacopydlg_dlginfo *datacopydlg_create(char *title,
					int totalsize,
					GtkSignalFunc stophandler,
					gpointer data);

	
#endif // DATACOPYDLG_H
