/* piping functions for data filters and cd writing */

#ifndef PIPING_H
#define PIPING_H

#include <gtk/gtk.h>

#define PIPING_MAX_ARGS 10
#define PIPING_PIDWATCH_TIMEOUT 500

typedef int(*piping_finishcb)(int status,gpointer data);

typedef struct 
{
	int  pid;
	int  status;  // status as given back by waitpid
	int  handle;  // handle for timer
	piping_finishcb finishcb;
	gpointer data;
} piping_watch;
	
int piping_create(char *command,int *in,int *out,int *err);
piping_watch *piping_pidwatch_add(int pid,
				  piping_finishcb,
				  gpointer data);
void piping_pidwatch_remove(piping_watch*);

#endif PIPING_H
