/* this preferences Files is an attempt of collecting whatever there
 * is in config options,so that they can be combined into some 
 * preferences dialog more easily...
 */

#ifndef PREFERENCES_H
#define PREFERENCES_H

#include <gtk/gtk.h>

#include "varman.h"

void preferences_init(int argc,char **argv);
void preferences_exit();
/* any handler passed to this function is called if either OK or Apply is
 * clicked by the user. This will generally be used by varmanwidgets to
 * update their variables */
void preferences_setapplyhandler(GtkSignalFunc,gpointer);
/* any handler passed to this function is called after values entered
 * in the preferences setup have become invalid because the user has  
 * clicked the cancel button */
void preferences_setundohandler(GtkSignalFunc,gpointer);

extern GtkWidget *preferences_editmain; /* use this to show preferences */
extern GtkWidget *preferences_editpad;  /* use this to add pages */
extern GtkWidget *preferences_common; 

#define MAX_GLOBAL_DEFS 256
extern varman_database *global_defs;
#define MAX_DYNAMIC_DEFS 10
extern varman_database *dynamic_defs;

#define FSEDIT_DESTPATH varman_getvar(global_defs,"fsedit_destpath")
#define TEMPDIR varman_getvar(global_defs,"tempdir")
#define RECORDER varman_getvar(global_defs,"recorder")

/* currently cannot be changed at runtime */
#define BUFSIZE 4096

#endif // PREFERENCES_H
