/* Filelist Widget */

#ifndef SELECTLIST_H
#define SELECTLIST_H

#include <gtk/gtk.h>

typedef void (*selectlist_dropcallback) (char*s);

typedef struct 
{
	GtkCList *self;                       /* points to the CList itself for referencing */
	char selection[32768];                /* currently selected entries,already in drag and drop compatible form */
	char header[256];                     /* header to append to entry names (e.g. file:/pub/Linux/Software/) */
	int  significant_column;              /* this column is being passed by drag and drop */
	selectlist_dropcallback receiver;     /* highlevel callback when new files have arrived for current selectlist */
	int  send;
	int  popup;
	GtkSignalFunc item_remove;   /* simply called with a selection list */
	GtkSignalFunc mkdir;         /* called with a pointer to the header[256] field of this structure */
	GtkSignalFunc doubleclick;   /* simply called with a selection list */
} selectlist_info;

selectlist_info *selectlist_info_create(char *header,int significant_column,
					selectlist_dropcallback receiver,
					int send,int popup,
					GtkSignalFunc item_remove,
					GtkSignalFunc mkdir,
					GtkSignalFunc doubleclick);
GtkWidget *selectlist_create(selectlist_info *selectlist,int columns);
// create a selectlist
// a selectlist created by selectlist_create is far from being complete
// for the high level program selectlist_create roughly corresponds to the
// common gtk function gtk_clist_new. hence it still has to be inserted into
// a scrolling area,also there are no entries defined yet
	
#endif // SELECTLIST_H
