/* tracktype for all unidentified raw data files */

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>

#include "tracks.h"
#include "stdfiletrack.h"

int stdfiletrack_openpipe(void*trackinfo)
{	
	stdfiletrack_info *i;
	
	i=(stdfiletrack_info*)((tracks_trackinfo*)trackinfo)->data;

	if (i->filedes==-1)
	  {
		  i->filedes=open((char*)&i->filename,O_RDONLY);
		  if (i->filedes==-1)
		      perror ("error opening data track");	
	  }
	;
	return i->filedes;
}
;

void stdfiletrack_closepipe(void*trackinfo)
{
	stdfiletrack_info *i;
	
	i=(stdfiletrack_info*)((tracks_trackinfo*)trackinfo)->data;
	if (i->filedes!=-1)
	  {		  
		  close(i->filedes);
		  i->filedes=-1;
	  }
	;
	
}
;

int stdfiletrack_tracksize(void*trackinfo)
{
	stdfiletrack_info *i;
	int fd;
	int pos=0;
	
	i=(stdfiletrack_info*)((tracks_trackinfo*)trackinfo)->data;
	
	fd=open((char*)&i->filename,O_RDONLY);
	if (fd!=-1)
	  {		  
		  pos=lseek(fd,0,SEEK_END);
		  close(fd);
	  }
	;	
	return pos;
}
;

int stdfiletrack_dataavail(void*trackinfo)
{
	stdfiletrack_info *i;

	i=(stdfiletrack_info*)((tracks_trackinfo*)trackinfo)->data;

	return (i->filedes!=-1);
}
;	

int  stdfiletrack_valid(void*trackinfo)  /* isotrack is always valid */
{
	return 1;
}
;

void stdfiletrack_destroy(void*trackinfo)
{
	stdfiletrack_info *i;
	
	i=(stdfiletrack_info*)((tracks_trackinfo*)trackinfo)->data;
	
	if (stdfiletrack_dataavail(trackinfo))
	    close (i->filedes);
	free(i);
}
;

tracks_trackinfo *stdfiletrack_create(char *filename)
{
	tracks_trackinfo *dt;
	stdfiletrack_info *info;
	char description[256];
	
	info=(stdfiletrack_info*)malloc(sizeof(stdfiletrack_info));
	strcpy((char*)&info->filename,filename);
	info->filedes=-1;

	strcpy((char*)&description,"Raw data file ");
	strcat((char*)&description,filename);
	dt=tracks_create((char*)&description,
			 data,none,
			 stdfiletrack_openpipe,
			 stdfiletrack_closepipe,
			 stdfiletrack_tracksize,
			 stdfiletrack_dataavail,
			 stdfiletrack_valid,
			 stdfiletrack_destroy,
			 info);
	return dt;
}
;

	
